<?php

/**
 * @copyright	Copyright (C) 2011-2019 Cedric KEIFLIN alias ced1870
 * https://www.joomlack.fr
 * @license		GNU/GPL
 * */
defined('JPATH_PLATFORM') or die;

include_once JPATH_ROOT . '/administrator/components/com_accordeonmenuck/helpers/defines.php';

// custom class extension for J3 compatibility
if (class_exists('\Joomla\CMS\Form\Field\TextField')) {
	class JFormFieldAccordeonmenucktextBase extends \Joomla\CMS\Form\Field\TextField {}
} else {
	class JFormFieldAccordeonmenucktextBase extends JFormFieldText {}	
}

class JFormFieldAccordeonmenucktext extends JFormFieldAccordeonmenucktextBase {

	/**
	 * The form field type.
	 *
	 * @var    string
	 */
	protected $type = 'accordeonmenucktext';

	protected function getInput() {
		// Initialize some field attributes.
		$icon = $this->element['icon'];
		$suffix = $this->element['suffix'];

		$html = $icon ? '<div class="accordeonmenuck-field-icon" ' . ($suffix ? 'data-has-suffix="1"' : '') . '><img src="' . ACCORDEONMENUCK_MEDIA_URI . '/images/' . $icon . '" style="margin-right:5px;" /></div>' : '<div style="display:inline-block;width:20px;"></div>';

		$html .= parent::getInput();
		if ($suffix)
			$html .= '<span class="accordeonmenuck-field-suffix">' . $suffix . '</span>';
		return $html;
	}

}
